#import "MyController.h"

@implementation MyController

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    active = NO;
    indeterminate = NO;
    value = 0.0;

    [self startTimer];
}

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication
{
    return YES;
}

- (IBAction)toggleCursor:(id)sender
{
    QDDisplayWaitCursor([sender state]);
}

- (IBAction)toggleActive:(id)sender
{
    active = [sender state];

    if (active)
    {
        [bar1 startAnimation: sender];
        [bar2 startAnimation: sender];
        [spin1 startAnimation: sender];
        [spin2 startAnimation: sender];
    }
    else
    {
        [bar1 stopAnimation: sender];
        [bar2 stopAnimation: sender];
        [spin1 stopAnimation: sender];
        [spin2 stopAnimation: sender];
    }
}

- (IBAction)toggleIndeterminate:(id)sender
{
    indeterminate = [sender state];

    [bar1 setIndeterminate: indeterminate];
    [bar2 setIndeterminate: indeterminate];

    if ( !active)
    {
        // this seems to be necessary although I'm not sure why it should be
        [bar1 stopAnimation: sender];
        [bar2 stopAnimation: sender];
    }
}

// this method is invoked via the timer
- (void)showProgress:(NSTimer *)theTimer
{
    if ( !active || indeterminate)
        return;

    value += 1.0;
    if (value > 100.0)
        value = 0.0;
    
    [bar1 setDoubleValue: value];
    [bar2 setDoubleValue: value];
}

- (void)startTimer
{
    if (timer != nil)
        return;

    timer = [[NSTimer scheduledTimerWithTimeInterval: 0.3
                                              target: self
                                            selector: @selector(showProgress:)
                                            userInfo: nil
                                             repeats: YES] retain];
}

- (void)stopTimer
{
    if (timer == nil)
        return;

    [timer invalidate];
    timer = nil;
}

@end
